package org.ginger.hibermapstest.model.perclass;

import java.util.HashMap;
import java.util.Map;

import javax.persistence.Access;
import javax.persistence.AccessType;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.MapKey;
import javax.persistence.OneToMany;
import javax.persistence.Table;

import org.ginger.hibermapstest.model.Book;
import org.ginger.hibermapstest.model.Library;

@Entity
@Table(name="LIBRARYPC")
@Access(AccessType.FIELD)
public class LibraryImpl implements Library {
	@Id
	@GeneratedValue
	private int entid;

	@OneToMany(mappedBy="library", targetEntity=org.ginger.hibermapstest.model.perclass.BookImpl.class)
	@MapKey(name="inventoryCode")
	private Map<String,Book> booksOnInventory = new HashMap<String,Book>();
	
	public LibraryImpl() {
		
	}
	
	@Override
	public int getEntid() {
		return entid;
	}
	
	@Override
	public Map<String,Book> getBooksOnInventory() {
		return booksOnInventory;
	}
}
